local TSM = select(2, ...)
TSM = LibStub("AceAddon-3.0"):NewAddon(TSM, "TSM_CoolDowns", "AceEvent-3.0", "AceConsole-3.0")
TSM.version = GetAddOnMetadata("TradeSkillMaster_CoolDowns", "Version")
local AceGUI = LibStub("AceGUI-3.0") -- load the AceGUI libraries

-- Vars
TSM.CraftCDs = nil


local savedDBDefaults = { --- Default the saved variables
	factionrealm = {
		["CoolDowns"] = {
			["*"] = {
				["Name"] = nil,
				["spellID"] = 1,
				["Enabled"] = true,
				["LastChecked"] = 0, --Timing NYI
			},
		},
	},
}



function TSM:OnInitialize()
	
	TSM.db = LibStub:GetLibrary("AceDB-3.0"):New("TradeSkillMaster_CoolDownsDB", savedDBDefaults, true)
	
	-- make easier references to all the modules
	for moduleName, module in pairs(TSM.modules) do
		TSM[moduleName] = module
	end
	
	TSM:RegisterModule()
end

function TSM:OnEnable() -- things that need ot be enabled when addon is loaded.
	TSM:CreateItemCoolDownSV() -- Creates the SV for items
end

function TSM:RegisterModule()
	
	TSM.icons = {
		{ side = "module", desc = "CoolDowns", slashCommand = "cooldowns", callback = "Options:Load", icon = "Interface\\Icons\\TRADE_ARCHAEOLOGY_SILVERSCROLLCASE" },
	} -- need new icon.
	
	TSMAPI:NewModule(TSM)
end

function TSM:CreateItemCoolDownSV() -- Creates the SV for items
	TSM.CraftCDs = TSMAPI:ModuleAPI("Crafting", "getCDCrafts") -- Load the TSM cd crafts
	if TSM.CraftCDs == nil then TSM:Print("ERROR: Table, returned nil. Please report this error to the addon owner on curse.") return end -- return if not recieveing
	
	for ID,Name in pairs(TSM.CraftCDs) do
		--print(ID,Name)
		TSM.db.factionrealm["CoolDowns"][ID]["Name"] = Name -- initiate item
		TSM.db.factionrealm["CoolDowns"][ID]["spellID"] = ID	-- initiate item
	end
end
